

var SWClickListener;

function SkinYourWebClickListener() 
{
}

SkinYourWebClickListener.prototype = 
{
  mbListening: true,
  mTargetDocs: null,

  startClickListener: function()
  {
    this.mbListening = true;
    this.mTargetDocs = this.getAllDocuments();

    for (var i = 0; i < this.mTargetDocs.length; ++i) {
      this.mTargetDocs[i].addEventListener("mousedown", SWMouseDownListener, false);
      this.mTargetDocs[i].addEventListener("mouseup", SWEventCanceller, false);
      this.mTargetDocs[i].addEventListener("click", SWListenerRemover, false);
    }
  },

  stopClickListener: function(aTarget)
  {
    this.mbListening = false;
    SWToggleColorMonitoring(true);
  },

  removeClickListeners: function()
  {

    if (this.mTargetDocs == null) {
	// we never installed the listeners
	return;
    }
    for (var i = 0; i < this.mTargetDocs.length; ++i) {
      this.mTargetDocs[i].removeEventListener("mousedown", SWMouseDownListener, false);
      this.mTargetDocs[i].removeEventListener("mouseup", SWEventCanceller, false);
      this.mTargetDocs[i].removeEventListener("click", SWListenerRemover, false);
    }
  },

  // currently, returns only the main window
  getAllDocuments: function()
  {
	return [window];
  },
}  


// Listener Objects
var SWMouseDownListener = {
  handleEvent: function(aEvent)
  {
    var target = aEvent.target;
	 aEvent.stopPropagation();
      aEvent.preventDefault();
	var str='';
	try{
	var ctr=0;
	 for(var list in target.ownerDocument){
     //str+=" "+list+"     ";
	 ctr++;
	 }
	 }
	 catch(e){
	 ctr=0;
	 }
   if (ctr>50) return;
    if (aEvent.type == "mousedown") {
     
	  e = aEvent.button;
      if (aEvent.shiftKey && e==0) {
		SWhandleshiftClick(target);
		return;
      } else 
	 
	   if (e==0){
		// no shift, no alt, stop listening
		SWhandleClick(target);
	//	SWClickListener.stopClickListener(target);
      }
	  
	}
  }
};

var SWEventCanceller = {
  handleEvent: function(aEvent)
  {
    aEvent.stopPropagation();
    aEvent.preventDefault();
	
	 if (aEvent.button == 2){
		SWClickListener.removeClickListeners();
		SWClickListener.stopClickListener(aEvent.target);
		return;
      }
  }
};

var SWListenerRemover = {
  handleEvent: function(aEvent)
  {
      if (aEvent.type == "click") {
        aEvent.stopPropagation();
        aEvent.preventDefault();
      }
    
  }
};


SWClickListener = new SkinYourWebClickListener();

